
// PrintRawSDIDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PrintRawSDI.h"
#include "PrintRawSDIDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CPrintRawSDIDlg dialog




CPrintRawSDIDlg::CPrintRawSDIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPrintRawSDIDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pData = NULL;
	m_nDataSize = 0;
	m_pData16 = NULL;
	m_nDataSize16 = 0;
}

void CPrintRawSDIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_FILENAME, m_FileName);
	DDX_Control(pDX, IDC_NUMBER, m_NumberEdit);
	DDX_Control(pDX, IDC_TEXT, m_Text);
}

BEGIN_MESSAGE_MAP(CPrintRawSDIDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_FILE, &CPrintRawSDIDlg::OnBnClickedFile)
	ON_BN_CLICKED(IDC_PRINT_VBI, &CPrintRawSDIDlg::OnBnClickedPrintVbi)
	ON_BN_CLICKED(IDC_SCAN_VBI, &CPrintRawSDIDlg::OnBnClickedScanVbi)
	ON_BN_CLICKED(IDC_PRINT_PACKETS, &CPrintRawSDIDlg::OnBnClickedPrintPackets)
END_MESSAGE_MAP()


// CPrintRawSDIDlg message handlers

BOOL CPrintRawSDIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	GetDlgItem(IDC_PRINT_VBI)->EnableWindow(FALSE);
	GetDlgItem(IDC_SCAN_VBI)->EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPrintRawSDIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPrintRawSDIDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPrintRawSDIDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CPrintRawSDIDlg::OnBnClickedFile()
{
	CFileDialog dlg(TRUE, _T(".raw"), NULL, OFN_FILEMUSTEXIST);
	if( dlg.DoModal()==IDOK ) {
		ClearData();
		GetDlgItem(IDC_PRINT_VBI)->EnableWindow(FALSE);
		GetDlgItem(IDC_SCAN_VBI)->EnableWindow(FALSE);
		m_NumberEdit.SetWindowText(_T("-1"));
		m_Text.SetWindowText(_T(""));
		if( ReadRawData(dlg.GetPathName()) ) {
			m_szFileName = dlg.GetPathName();
			m_FileName.SetWindowText(dlg.GetPathName());
			GetDlgItem(IDC_PRINT_VBI)->EnableWindow(TRUE);
			GetDlgItem(IDC_SCAN_VBI)->EnableWindow(TRUE);
		} else  ClearData();
	}
}

void CPrintRawSDIDlg::OnBnClickedScanVbi()
{
	CString str;
	m_NumberEdit.GetWindowText(str);
	int nLine = _ttoi(str);
	nLine = ScanVBI(nLine+1);
	str.Format(_T("%d"),nLine);
	m_NumberEdit.SetWindowText(str);
}

void CPrintRawSDIDlg::OnBnClickedPrintVbi()
{
	CString str;
	m_NumberEdit.GetWindowText(str);
	int nLine = _ttoi(str);
	CString text = PrintVBI(nLine);
	m_Text.SetWindowText(text);
}

void CPrintRawSDIDlg::OnBnClickedPrintPackets()
{
	CString str;
	m_NumberEdit.GetWindowText(str);
	int nLine = _ttoi(str);
	CString text = PrintPackets(nLine);
	m_Text.SetWindowText(text);
}


const int cDX = 2640; // raw HD-SDI line width (pixels)
const int cX0 = 2640-1920; // VBI data at the end of line
const int cVBI = 1920;

bool CPrintRawSDIDlg::ReadRawData(CString szFileName)
{
	HANDLE hFile = CreateFile(szFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	ATLASSERT(hFile != INVALID_HANDLE_VALUE);
	if( hFile==INVALID_HANDLE_VALUE )  return false;
	// obtain file size
	DWORD tmp=0;
	m_nDataSize = GetFileSize(hFile,&tmp);
	ATLASSERT(m_nDataSize > 0);
	ATLASSERT(tmp==0);
	m_nDataSize16 = m_nDataSize * 4 / 5;
	// allocate data
	m_pData = new BYTE[m_nDataSize];
	ATLASSERT(m_pData != NULL);
	if( m_pData==NULL )  return false;
	m_pData16 = new WORD[m_nDataSize16];
	ATLASSERT(m_pData16 != NULL);
	if( m_pData16==NULL )  return false;
	// read data
	tmp = m_nDataSize;
	if( !ReadFile(hFile, m_pData,m_nDataSize,&tmp, NULL) ) {
		int err = GetLastError();
		ATLASSERT(FALSE);
		return false;
	}
	ATLASSERT(tmp==m_nDataSize);
	CloseHandle(hFile);
	// convert raw data to UYVY
	BYTE *pi = m_pData;
	WORD *po = m_pData16;
	WORD *poe = m_pData16 + m_nDataSize16;
	while (po < poe) {
		ULONG	v	=	*((ULONG*)pi);
		po[0] = (v >> 00) & 0x3ff;
		po[1] = (v >> 10) & 0x3ff;
		po[2] = (v >> 20) & 0x3ff;
		po[3] = ((v >> 30) & 0x3) + (USHORT(pi[4]) << 2);
		po += 4;
		pi += 5;
	}
	return true;
}

int CPrintRawSDIDlg::ScanVBI(int nLine)
{
	WORD *ptr = &m_pData16[cDX*2 * nLine];
	while( nLine < 25 ) {
		// scip non-VBI data
		ptr += cX0 * 2;
		for( int i=0; i<cVBI; i++ ) {
			if( ptr[0] != (0x80<<2)  ||  ptr[1] != (0x10<<2) ) {
				return nLine;
			}
			ptr += 2;
		}
		nLine++;
	}
	return -1;
}

CString CPrintRawSDIDlg::PrintVBI(int nLine)
{
	WORD *ptr = &m_pData16[cDX*2 * nLine];
	CString str;
	for( int i=0; i<cDX; i+=2 ) {
		if( (i%16)==0 ) { CString s1; s1.Format(_T("\r\n0x%04X:"),i*2); str += s1; }
		CString s; s.Format(_T("   %03X,%03X,%03X,%03X,"), ptr[0],ptr[1],ptr[2],ptr[3]); str += s;
		ptr += 4;
	}
	return str;
}

CString CPrintRawSDIDlg::PrintPackets(int nLine)
{
	CString str;
	// UV plane
	WORD *ptr = &m_pData16[cDX*2 * nLine + cX0*2];
	for( int i=0; i<cVBI; ) {
		if( ptr[0]==0x000 && ptr[2]==0x3FF && ptr[4]==0x3FF ) {
			int n=0;
			str += PrintPacket(ptr,n, _T("UV"),i);
			i += n;
			ptr += n*2;
		} else {
			i++;
			ptr += 2;
		}
	}
	// Y plane
	ptr = &m_pData16[cDX*2 * nLine + cX0*2 + 1];
	for( int i=0; i<cDX; ) {
		if( ptr[0]==0x000 && ptr[2]==0x3FF && ptr[4]==0x3FF ) {
			int n=0;
			str += PrintPacket(ptr,n, _T("Y"),i);
			i += n;
			ptr += n*2;
		} else {
			i++;
			ptr += 2;
		}
	}
	return str;
}

CString CPrintRawSDIDlg::PrintPacket(WORD *ptr, int &skipSize, CString szPlane, int nOffset)
{
	CString str;
	bool bParityError = false;
	BYTE nDID = (BYTE)ptr[3*2];
	BYTE nSDID = (BYTE)ptr[4*2];
	BYTE nDC = (BYTE)ptr[5*2];
	int nOffsetVBI = nOffset - cX0;
	skipSize = 6 + nDC + 1;
	// check parity
	for( int i=3; i<skipSize-1; i++ ) {
		WORD value = ptr[i*2] & 0x3FF;
		int n = (value & 0x01) ^ ((value>>1) & 0x01) ^ ((value>>2) & 0x01) ^ ((value>>3) & 0x01) ^
				((value>>4) & 0x01) ^ ((value>>5) & 0x01) ^ ((value>>6) & 0x01) ^ ((value>>7) & 0x01);
		if( n != ((value>>8) & 0x01)  ||  n == ((value>>9) & 0x01) )
			bParityError = true;
	}
	ptr += 6*2;
	str.Format(_T("%s-plane packet, line_offset=0x%X(%d.), VBI_offset=0x%X(%d.), DID=0x%X, SDID=0x%X, DC=0x%X(%d.), UserData:\r\n"),
			   szPlane, nOffset,nOffset, nOffsetVBI,nOffsetVBI, nDID,nSDID, nDC,nDC);
	BYTE sum1 = nDID + nSDID + nDC;
	for( int i=0; i<nDC; i++ ) {
		CString s;
		s.Format(_T("%02X, "), (BYTE)ptr[i*2]);
		str += s;
		sum1 += ptr[i*2];
	}
	ptr += nDC*2;
	BYTE sum2 = (BYTE)ptr[0];
	CString s2;
	s2.Format(_T("\r\n- checksum %s: need=0x%X, has=0x%X,  parity %s\r\n"), sum1==sum2 ? _T("OK") : _T("ERROR"), sum1,sum2, bParityError ? _T("ERROR") : _T("OK"));
	str += s2;
	return str;
}
